CONFIG_FILE_NAME = 'config.py'

WB_HARDWARE_CONF_FILE_PATH = "/etc/wb-hardware.conf"

SETTINGS_MQTT_TOPIC = "/iq/bridge/network_manager/settings"
STORAGE_MQTT_TOPIC = "/iq/bridge/network_manager/storage"  # local topic

RESULT_MQTT_TOPIC = "/iq/bridge/network_manager/log"
STAT_MQTT_TOPIC = "/iq/bridge/network_manager/stat"

DEFAULT_TIMEOUT = 15
GSM_TIMEOUT = 15  # DEFAULT_TIMEOUT

EMPTY_MODEM_SETTINGS = {}

LINUX_INTERFACES_FILE_PATH = "/etc/network/interfaces"
LINUX_INTERFACES_BACKUP_FILE_PATH = "/etc/network/interfaces.bak"

DEFAULT_MODEM_DEV = '/dev/ttyGSM'
DEFAULT_4G_MODEM_DEV = '/dev/ttyUSB2'

PPP_PROVIDER = "mts"
PPP_PROVIDER_FILE_PATH = '/etc/ppp/peers/{0}'.format(PPP_PROVIDER)

LO_INTERFACE_NAME = "lo"
ETH0_INTERFACE_NAME = "eth0"
ETH1_INTERFACE_NAME = "eth1"
WLAN_INTERFACE_NAME = "wlan0"
FREE_WLAN_INTERFACE_NAME = "wlan0_free"
PPP_INTERFACE_NAME = "ppp0"
USB0_INTERFACE_NAME = "usb0"


LO_INTERFACE_TEMPLATE = """
auto {0}
iface {0} inet loopback
"""

ETH_INTERFACE_TEMPLATE = """
auto {0}
allow-hotplug {0}

iface {0} inet dhcp
    pre-up wb-set-mac
    hostname IQnergy
"""

PPP_INTERFACE_TEMPLATE = """
auto {{0}}
allow-hotplug {{0}}

iface {{0}} inet ppp
    provider {0}
    pre-up wb-gsm restart_if_broken
    pre-up sleep {1}
""".format(PPP_PROVIDER, GSM_TIMEOUT)

WLAN_INTERFACE_TEMPLATE = """
auto {0}
allow-hotplug {0}

iface {0} inet dhcp
    wpa-ssid "{{0}}"
    wpa-psk "{{1}}"
"""

FREE_WLAN_INTERFACE_TEMPLATE = """
auto {0}
allow-hotplug {0}

iface {0} inet dhcp
    wireless-essid "{{0}}"
"""

USB0_INTERFACE_TEMPLATE = """
auto {0}
allow-hotplug {0}

iface {0} inet dhcp
   hostname IQnergy
   pre-up wb-gsm restart_if_broken
"""

INTERFACE_SETTINGS_TEMPLATE = {
    LO_INTERFACE_NAME: (LO_INTERFACE_TEMPLATE.format(LO_INTERFACE_NAME), 0),
    ETH0_INTERFACE_NAME: (ETH_INTERFACE_TEMPLATE.format(ETH0_INTERFACE_NAME), 1),
    ETH1_INTERFACE_NAME: (ETH_INTERFACE_TEMPLATE.format(ETH1_INTERFACE_NAME), 2),
    PPP_INTERFACE_NAME: (PPP_INTERFACE_TEMPLATE.format(PPP_INTERFACE_NAME), 3),
    WLAN_INTERFACE_NAME: (WLAN_INTERFACE_TEMPLATE.format(WLAN_INTERFACE_NAME), 4),
    USB0_INTERFACE_NAME: (USB0_INTERFACE_TEMPLATE.format(USB0_INTERFACE_NAME), 5)
}

FREE_WLAN_INTERFACE_DATA = FREE_WLAN_INTERFACE_TEMPLATE.format(WLAN_INTERFACE_NAME)
# USB0_INTERFACE_DATA = USB0_INTERFACE_TEMPLATE.format(USB0_INTERFACE_NAME)

BASE_INTERFACES = [LO_INTERFACE_NAME, ETH0_INTERFACE_NAME, ETH1_INTERFACE_NAME, PPP_INTERFACE_NAME]

DEFAULT_INTERFACE_PRIORITY = 0

DEFAULT_SETTINGS = {
    PPP_INTERFACE_NAME: {
        "priority": -2
    },
    WLAN_INTERFACE_NAME: {
        # "is_active": False,
        "priority": -1,
        "ssid": "IQnetwork",
        "key": "Smart_Password!"
    },
    ETH1_INTERFACE_NAME: {
        "is_active": False
    }
}
